## bifrost 0.1.3

=== DESCRIPTION ===
Package: bifrost
Title: Branch-Level Inference Framework for Recognizing Optimal Shifts
        in Traits
Version: 0.1.3
Authors@R: c(
    person(given = c("Jacob", "S."), family = "Berv", email = "jacob.berv@gmail.com", role = c("aut", "cre", "cph", "fnd"), comment = c(ORCID = "0000-0002-5962-0621")),
    person(given = "Nathan", family = "Fox", role = "aut", comment = c(ORCID = "0000-0002-2816-9751")),
    person(given = c("Matthew", "J."), family = "Thorstensen", role = "aut", comment = c(ORCID = "0000-0002-7870-3369")),
    person(given = "Henry", family = "Lloyd-Laney", role = "aut", comment = c(ORCID = "0000-0003-4650-8937")),
    person(given = c("Emily", "M."), family = "Troyer", role = "aut", comment = c(ORCID = "0000-0001-7478-2306")),
    person(given = c("Stephen", "A."), family = "Smith", role = c("aut", "fnd"), comment = c(ORCID = "0000-0003-2035-9531")),
    person(given = "Matt", family = "Friedman", role = c("aut", "fnd"), comment = c(ORCID = "0000-0002-0114-7384")),
    person(given = c("David", "F."), family = "Fouhey", role = c("aut", "fnd"), comment = c(ORCID = "0000-0001-5028-5161")),
    person(given = c("Brian", "C."), family = "Weeks", role = c("aut", "fnd"), comment = c(ORCID = "0000-0003-2967-2970")))
Description: Methods for detecting and visualizing cladogenic shifts in multivariate trait data on phylogenies. Implements penalized-likelihood multivariate generalized least squares models, enabling analyses of high-dimensional trait datasets and large trees via searchOptimalConfiguration(). Includes a greedy step-wise shift-search algorithm following approaches developed in Smith et al. (2023) <doi:10.1111/nph.19099> and Berv et al. (2024) <doi:10.1126/sciadv.adp0114>. Methods build on multivariate GLS approaches described in Clavel et al. (2019) <doi:10.1093/sysbio/syy045> and implemented in the mvgls() function from the 'mvMORPH' package. Documentation and vignettes are available at <https://jakeberv.com/bifrost/>, including the introductory vignette at <https://jakeberv.com/bifrost/articles/jaw-shape-vignette.html>.
License: GPL (>= 2)
Encoding: UTF-8
RoxygenNote: 7.3.3
URL: https://jakeberv.com/bifrost/, https://github.com/jakeberv/bifrost
BugReports: https://github.com/jakeberv/bifrost/issues
Depends: R (>= 4.1)
Imports: ape, future, future.apply, phytools, grDevices, stats,
        mvMORPH, viridis, txtplot
Suggests: HDInterval, RColorBrewer, boot, classInt, evd, fitdistrplus,
        knitr, palaeoverse, parallel, patchwork, pbmcapply, phylolm,
        readxl, rmarkdown, scales, testthat (>= 3.0.0), univariateML,
        spelling, htmltools
VignetteBuilder: knitr
Config/testthat/edition: 3
Config/testthat/parallel: false
Language: en-US
NeedsCompilation: no
Packaged: 2026-01-15 21:51:32 UTC; cotinga
Author: Jacob S. Berv [aut, cre, cph, fnd] (ORCID:
    <https://orcid.org/0000-0002-5962-0621>),
  Nathan Fox [aut] (ORCID: <https://orcid.org/0000-0002-2816-9751>),
  Matthew J. Thorstensen [aut] (ORCID:
    <https://orcid.org/0000-0002-7870-3369>),
  Henry Lloyd-Laney [aut] (ORCID:
    <https://orcid.org/0000-0003-4650-8937>),
  Emily M. Troyer [aut] (ORCID: <https://orcid.org/0000-0001-7478-2306>),
  Stephen A. Smith [aut, fnd] (ORCID:
    <https://orcid.org/0000-0003-2035-9531>),
  Matt Friedman [aut, fnd] (ORCID:
    <https://orcid.org/0000-0002-0114-7384>),
  David F. Fouhey [aut, fnd] (ORCID:
    <https://orcid.org/0000-0001-5028-5161>),
  Brian C. Weeks [aut, fnd] (ORCID:
    <https://orcid.org/0000-0003-2967-2970>)
Maintainer: Jacob S. Berv <jacob.berv@gmail.com>
Repository: CRAN
Date/Publication: 2026-01-21 19:10:19 UTC

## bifrost 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(Bifrost C CXX)
find_package(Threads REQUIRED)

# To enable a larger default k-mer size, replace MAX_KMER_SIZE with a larger multiple of 32: actual maximum k-mer size will be MAX_KMER_SIZE-1.
SET(MAX_KMER_SIZE "32" CACHE STRING "MAX_KMER_SIZE")
SET(MAX_GMER_SIZE "${MAX_KMER_SIZE}" CACHE STRING "MAX_GMER_SIZE")
# Enable architecture optimizations
SET(COMPILATION_ARCH "native" CACHE STRING "COMPILATION_ARCH")
# Enable AVX2 instructions
SET(ENABLE_AVX2 "ON" CACHE STRING "ENABLE_AVX2")

# Set some default compile flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

set(CMAKE_MACOSX_RPATH 1)

set_property(SOURCE BlockedBloomFilter.cpp APPEND_STRING PROPERTY COMPILE_FLAGS " -funroll-loops")

if(APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm")
       message("Disabling AVX2 instructions on arm64")
       set(ENABLE_AVX2 "OFF")
       set(COMPILATION_ARCH "OFF")
endif(APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm")


if(COMPILATION_ARCH MATCHES "OFF")
	message("Disabling native architecture compilation (including AVX2)")
else(COMPILATION_ARCH MATCHES "OFF")
	message("Compilation architecture: ${COMPILATION_ARCH}")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=${COMPILATION_ARCH}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${COMPILATION_ARCH}")
endif(COMPILATION_ARCH MATCHES "OFF")

if(ENABLE_AVX2 MATCHES "OFF")
	message("Disabling AVX2 instructions")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mno-avx2")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mno-avx2")
endif(ENABLE_AVX2 MATCHES "OFF")

# Manages build types 
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES Debug)
	message("Build type: Debug")
	add_compile_options(-g)
else(CMAKE_BUILD_TYPE MATCHES Debug)
	if(CMAKE_BUILD_TYPE MATCHES Profile)
		message("Build type: Profiling")
		add_compile_options(-pg)
		set(CMAKE_SHARED_LINKER_FLAGS "-pg")
		set(CMAKE_EXE_LINKER_FLAGS "-pg")
	else(CMAKE_BUILD_TYPE MATCHES Profile)
		message("Build type: Release")
		add_compile_options(-O3)
	endif(CMAKE_BUILD_TYPE MATCHES Profile)
endif(CMAKE_BUILD_TYPE MATCHES Debug)

MATH(EXPR PRINT_MAX_KMER_SIZE "${MAX_KMER_SIZE}-1")
message("Maximum k-mer size: " ${PRINT_MAX_KMER_SIZE})

MATH(EXPR PRINT_MAX_GMER_SIZE "${MAX_GMER_SIZE}-1")
message("Maximum g-mer size: " ${PRINT_MAX_GMER_SIZE})

add_subdirectory(src)

=== debian/changelog ===
bifrost (1.3.1-2) unstable; urgency=medium

  * Team upload.
  * d/p/0002-Fix-compilation-error-with-custom-unitig-data.patch:
    Fix FTBFS with GCC 15. (Closes: #1096367)
  * d/bifrost.examples: Remove bugs file.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 27 Sep 2025 14:33:42 -0400

bifrost (1.3.1-1) unstable; urgency=medium

  * Source-only upload.
  * New upstream version
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 05 Jan 2024 09:14:39 +0100

bifrost (1.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1055593)

 -- Andreas Tille <tille@debian.org>  Wed, 08 Nov 2023 19:53:14 +0100

## bifrost 1.3.5

=== src/CMakeLists.txt ===
file(GLOB sources *.cpp roaring.c)
file(GLOB headers *.h *.hpp *.hh *.tcc)

list(REMOVE_ITEM sources Bifrost.cpp)

add_definitions(-DMAX_KMER_SIZE=${MAX_KMER_SIZE})
add_definitions(-DMAX_GMER_SIZE=${MAX_GMER_SIZE})

add_library(bifrost_static STATIC ${sources} ${headers})
add_library(bifrost_dynamic SHARED ${sources} ${headers})

set_target_properties(bifrost_static PROPERTIES OUTPUT_NAME "bifrost")
set_target_properties(bifrost_dynamic PROPERTIES OUTPUT_NAME "bifrost")

target_include_directories(bifrost_static PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(bifrost_dynamic PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(Bifrost Bifrost.cpp)

find_package(Threads REQUIRED)
target_link_libraries(bifrost_static ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(bifrost_dynamic ${CMAKE_THREAD_LIBS_INIT})

find_package(ZLIB REQUIRED)
target_link_libraries(bifrost_static ${ZLIB_LIBRARIES})
target_link_libraries(bifrost_dynamic ${ZLIB_LIBRARIES})

if (ZLIB_FOUND)
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    message(FATAL_ERROR "zlib not found. Required for to output files")
endif(ZLIB_FOUND)

target_link_libraries(Bifrost bifrost_dynamic)

install(TARGETS Bifrost DESTINATION bin)
install(TARGETS bifrost_dynamic DESTINATION lib)
install(TARGETS bifrost_static DESTINATION lib)
install(FILES ${headers} DESTINATION include/bifrost)

=== debian/changelog ===
bifrost (1.3.5-2) unstable; urgency=medium

  * d/watch: version=5
  * Fix build with CMake 4
    Closes: #1112726
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 16 Oct 2025 11:07:24 +0200

bifrost (1.3.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.3.5
  * d/t/data/*: Add example data to git repository.
  * d/bifrost.examples: Bring back examples file.
    Now that there's data to be installed, we can bring back the examples
    file. (Closes: #1117180)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 04 Oct 2025 12:10:45 -0400

=== debian/control ===
Source: bifrost
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 d-shlibs,
 cmake,
 zlib1g-dev,
Vcs-Browser: https://salsa.debian.org/med-team/bifrost
Vcs-Git: https://salsa.debian.org/med-team/bifrost.git
Homepage: https://github.com/pmelsted/bifrost
Rules-Requires-Root: no

Package: bifrost
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: parallel construction, indexing and querying of de Bruijn graphs
 Bifrost is a command-line tool for sequencing that features a broad
 range of functions, such as indexing, editing, and querying the graph,
 and includes a graph coloring method that maps each k-mer of the graph
 to the genomes it occurs in.
 .
  * Build, index, color and query the compacted de Bruijn graph
  * No need to build the uncompacted de Bruijn graph
  * Reads or assembled genomes as input
  * Output graph in GFA (can be visualized with Bandage), FASTA or binary
  * Graph cleaning: short tip clipping, etc.
  * Multi-threaded
  * No parameters to estimate with other tools
  * Exact or approximate k-mer search of queries

Package: libbifrost0
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: library for parallel construction, indexing and querying of de Bruijn graphs
 Libbifrost is the shared library for the command-line tool bifrost for
 sequencing that features a broad range of functions, such as indexing,
 editing, and querying the graph, and includes a graph coloring method
 that maps each k-mer of the graph to the genomes it occurs in.
 .
  * Build, index, color and query the compacted de Bruijn graph
  * No need to build the uncompacted de Bruijn graph
  * Reads or assembled genomes as input
  * Output graph in GFA (can be visualized with Bandage), FASTA or binary
  * Graph cleaning: short tip clipping, etc.
  * Multi-threaded
  * No parameters to estimate with other tools
  * Exact or approximate k-mer search of queries

Package: libbifrost-dev
Architecture: any
Section: libdevel
Depends:
 libbifrost0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Description: static library and header files for libbifrost
 Libbifrost-dev is the development library for the command-line tool
 bifrost for sequencing that features a broad range of functions, such as
 indexing, editing, and querying the graph, and includes a graph coloring
 method that maps each k-mer of the graph to the genomes it occurs in.
 .
  * Build, index, color and query the compacted de Bruijn graph
  * No need to build the uncompacted de Bruijn graph
  * Reads or assembled genomes as input
  * Output graph in GFA (can be visualized with Bandage), FASTA or binary
  * Graph cleaning: short tip clipping, etc.
  * Multi-threaded
  * No parameters to estimate with other tools
  * Exact or approximate k-mer search of queries

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCOMPILATION_ARCH=OFF -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --movedev debian/tmp/usr/include/* usr/include \
                    debian/tmp/usr/lib/*.so

=== debian/watch ===
Version: 5

Template: Github
Owner: pmelsted
Project: bifrost
